%Author: Shebuti Rayana

function [AP,Precision,Recall] = AveragePrecision(RankList,GroundTruth,flag)
    m = length(RankList);
    [~,loc] = ismember(GroundTruth,RankList);
    index = sort(loc);
    Precision = [];
    Recall = [];
    TPR = [];
    FPR = [];
    
    for i = 1:length(index)
        TP = i;
        FP = index(i) - i;
        FN = length(index) - i;
        TN = m - TP - FP - FN;
        
        P = TP/(TP+FP);
        R = TP/(TP+FN);
        F = FP/(FP+TN);
        
        Precision = [Precision;P];
        Recall = [Recall;R];
    end
    
    AP = mean(Precision);
    
    if(flag)
        % PR plot
        color = '-r';
        h = figure;
        plot(Recall,Precision,color,'LineWidth',3);
        title(strcat('AP = ',num2str(AP)));
        xlabel('Recall','FontSize',16);
        ylabel('Precision','FontSize',16);
        set(gca,'FontSize',16);
    end
    
end